/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : Uebung_4-2.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Schreiben Sie Makros
              o MIN(x, y) liefert den kleineren der beiden Werte
			  o MAX(x, y) liefert den grsseren der beiden Werte
			  o SWAP(t,x,y) vertauscht die zwei Argumente x und y vom Typ t.
=================================================================================================*/

#include <stdio.h>
#include <stdlib.h>

#define MIN(x, y)		((x) < (y) ? (x) : (y))
#define MAX(x, y)		((x) > (y) ? (x) : (y))
#define SWAP(t, x, y)	{ t tmp; tmp = x; x = y; y = tmp; }

/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	int x, y;
	char* a, *b;

	x = 5;
	y = 10;
	a = "Hallo";
	b = "Du";

	printf("Value x: %i\n", x);
	printf("Value y: %i\n", y);
	printf("> Min: %i\n", MIN(x,y));
	printf("> Max: %i\n", MAX(x,y));
	printf("> Swap...\n");
	SWAP(int, x, y);
	printf("  > Value x: %i\n", x);
	printf("  > Value y: %i\n", y);

	printf("---------------------------------------\n");
	printf("String a: %s\n", a);
	printf("String b: %s\n", b);
	printf("> Min: %s\n", MIN(a,b));
	printf("> Max: %s\n", MAX(a,b));
	printf("> Swap...\n");
	SWAP(char*, a, b);
	printf("  > Value a: %s\n", a);
	printf("  > Value b: %s\n", b);


	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}
