/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : calc.h
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Taschenrechner polnische Notation
=================================================================================================*/

/* Konstanten */
#define NUMBER '0'		/* Anzeige, Zahl */
#define FN_SIN '-1'		/* Sinus */
#define FN_COS '-2'		/* Cosinus */
#define FN_TAN '-3'		/* Tangens */
#define FN_EXP '-4'		/* Exponent */
#define FN_POWER '-5'	/* Power */

/* Funktions-Deklaration */
void push(double f);	/* push: f auf den Stack bringen */
double pop(void);		/* pop: Wert von Stack holen und liefern */
int getop(char s[]);	/* getop: naechsten Operator und /oder numerischen Operanden holen */
int getch(void);		/* getch: Zeichen holen mit Buffer */
void ungetch(int c);	/* ungetch: Zeichen wieder zurueckstellen wenn zuviel geholt */
